"""
    Delphix DCT API

    Delphix DCT API  # noqa: E501

    The version of the OpenAPI document: 3.22.0
    Contact: support@delphix.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from delphix.api.gateway.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from delphix.api.gateway.exceptions import ApiAttributeError


def lazy_import():
    from delphix.api.gateway.model.execution_status import ExecutionStatus
    from delphix.api.gateway.model.execution_status_reason import ExecutionStatusReason
    globals()['ExecutionStatus'] = ExecutionStatus
    globals()['ExecutionStatusReason'] = ExecutionStatusReason


class JobCollectionExecution(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'compliance_job_collection_id': (str,),  # noqa: E501
            'compliance_job_collection_name': (str,),  # noqa: E501
            'status': (ExecutionStatus,),  # noqa: E501
            'status_reason': (ExecutionStatusReason,),  # noqa: E501
            'start_time': (datetime,),  # noqa: E501
            'end_time': (datetime,),  # noqa: E501
            'run_duration': (int,),  # noqa: E501
            'actual_execution_count': (int,),  # noqa: E501
            'planned_execution_count': (int,),  # noqa: E501
            'rows_processed': (int,),  # noqa: E501
            'rows_total': (int,),  # noqa: E501
            'bytes_processed': (int,),  # noqa: E501
            'bytes_total': (int,),  # noqa: E501
            'processed_tables_files_count': (int,),  # noqa: E501
            'tables_files_count': (int,),  # noqa: E501
            'processed_columns_fields_count': (int,),  # noqa: E501
            'columns_fields_count': (int,),  # noqa: E501
            'percent_complete': (int,),  # noqa: E501
            'execute_account_id': (int,),  # noqa: E501
            'execute_account_name': (str,),  # noqa: E501
            'cancel_account_id': (int,),  # noqa: E501
            'cancel_account_name': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'compliance_job_collection_id': 'compliance_job_collection_id',  # noqa: E501
        'compliance_job_collection_name': 'compliance_job_collection_name',  # noqa: E501
        'status': 'status',  # noqa: E501
        'status_reason': 'status_reason',  # noqa: E501
        'start_time': 'start_time',  # noqa: E501
        'end_time': 'end_time',  # noqa: E501
        'run_duration': 'run_duration',  # noqa: E501
        'actual_execution_count': 'actual_execution_count',  # noqa: E501
        'planned_execution_count': 'planned_execution_count',  # noqa: E501
        'rows_processed': 'rows_processed',  # noqa: E501
        'rows_total': 'rows_total',  # noqa: E501
        'bytes_processed': 'bytes_processed',  # noqa: E501
        'bytes_total': 'bytes_total',  # noqa: E501
        'processed_tables_files_count': 'processed_tables_files_count',  # noqa: E501
        'tables_files_count': 'tables_files_count',  # noqa: E501
        'processed_columns_fields_count': 'processed_columns_fields_count',  # noqa: E501
        'columns_fields_count': 'columns_fields_count',  # noqa: E501
        'percent_complete': 'percent_complete',  # noqa: E501
        'execute_account_id': 'execute_account_id',  # noqa: E501
        'execute_account_name': 'execute_account_name',  # noqa: E501
        'cancel_account_id': 'cancel_account_id',  # noqa: E501
        'cancel_account_name': 'cancel_account_name',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """JobCollectionExecution - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): The job collection execution ID.. [optional]  # noqa: E501
            compliance_job_collection_id (str): The ID of the compliance job collection executed.. [optional]  # noqa: E501
            compliance_job_collection_name (str): The name of the compliance job collection executed.. [optional]  # noqa: E501
            status (ExecutionStatus): [optional]  # noqa: E501
            status_reason (ExecutionStatusReason): [optional]  # noqa: E501
            start_time (datetime): The date and time that this job collection execution started.. [optional]  # noqa: E501
            end_time (datetime): The date and time that this job collection execution completed.. [optional]  # noqa: E501
            run_duration (int): The time this job collection execution spent running, in milliseconds.. [optional]  # noqa: E501
            actual_execution_count (int): The number of compliance jobs that were actually executed.. [optional]  # noqa: E501
            planned_execution_count (int): The number of compliance jobs that were planned to be executed.. [optional]  # noqa: E501
            rows_processed (int): The number of rows processed so far by this job collection execution. This is not applicable for JSON file type.. [optional]  # noqa: E501
            rows_total (int): The total number of rows for this job collection execution. This value is set after the job collection execution has completed successfully. This is not applicable for JSON file type.. [optional]  # noqa: E501
            bytes_processed (int): The number of bytes processed so far by this job collection execution. This is only applicable for JSON file type.. [optional]  # noqa: E501
            bytes_total (int): The total number of bytes for this job collection execution. This value is set after the job collectione execution has completed successfully. This is only applicable for JSON file type.. [optional]  # noqa: E501
            processed_tables_files_count (int): The number of tables or files processed so far by this job collection execution.. [optional]  # noqa: E501
            tables_files_count (int): The total number of tables or files for this job collection execution.. [optional]  # noqa: E501
            processed_columns_fields_count (int): The number of columns or fields processed so far by this job collection execution.. [optional]  # noqa: E501
            columns_fields_count (int): The total number of columns or fields for this job collection execution.. [optional]  # noqa: E501
            percent_complete (int): The percentage of completion of this job collection execution.. [optional]  # noqa: E501
            execute_account_id (int): The account id of the DCT user who started this job collection execution.. [optional]  # noqa: E501
            execute_account_name (str): The account name of the DCT user who started this job collection execution.. [optional]  # noqa: E501
            cancel_account_id (int): The account id of the DCT user who cancelled this job collection execution.. [optional]  # noqa: E501
            cancel_account_name (str): The account name of the DCT user who cancelled this job collection execution.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """JobCollectionExecution - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): The job collection execution ID.. [optional]  # noqa: E501
            compliance_job_collection_id (str): The ID of the compliance job collection executed.. [optional]  # noqa: E501
            compliance_job_collection_name (str): The name of the compliance job collection executed.. [optional]  # noqa: E501
            status (ExecutionStatus): [optional]  # noqa: E501
            status_reason (ExecutionStatusReason): [optional]  # noqa: E501
            start_time (datetime): The date and time that this job collection execution started.. [optional]  # noqa: E501
            end_time (datetime): The date and time that this job collection execution completed.. [optional]  # noqa: E501
            run_duration (int): The time this job collection execution spent running, in milliseconds.. [optional]  # noqa: E501
            actual_execution_count (int): The number of compliance jobs that were actually executed.. [optional]  # noqa: E501
            planned_execution_count (int): The number of compliance jobs that were planned to be executed.. [optional]  # noqa: E501
            rows_processed (int): The number of rows processed so far by this job collection execution. This is not applicable for JSON file type.. [optional]  # noqa: E501
            rows_total (int): The total number of rows for this job collection execution. This value is set after the job collection execution has completed successfully. This is not applicable for JSON file type.. [optional]  # noqa: E501
            bytes_processed (int): The number of bytes processed so far by this job collection execution. This is only applicable for JSON file type.. [optional]  # noqa: E501
            bytes_total (int): The total number of bytes for this job collection execution. This value is set after the job collectione execution has completed successfully. This is only applicable for JSON file type.. [optional]  # noqa: E501
            processed_tables_files_count (int): The number of tables or files processed so far by this job collection execution.. [optional]  # noqa: E501
            tables_files_count (int): The total number of tables or files for this job collection execution.. [optional]  # noqa: E501
            processed_columns_fields_count (int): The number of columns or fields processed so far by this job collection execution.. [optional]  # noqa: E501
            columns_fields_count (int): The total number of columns or fields for this job collection execution.. [optional]  # noqa: E501
            percent_complete (int): The percentage of completion of this job collection execution.. [optional]  # noqa: E501
            execute_account_id (int): The account id of the DCT user who started this job collection execution.. [optional]  # noqa: E501
            execute_account_name (str): The account name of the DCT user who started this job collection execution.. [optional]  # noqa: E501
            cancel_account_id (int): The account id of the DCT user who cancelled this job collection execution.. [optional]  # noqa: E501
            cancel_account_name (str): The account name of the DCT user who cancelled this job collection execution.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
