"""
    Delphix DCT API

    Delphix DCT API  # noqa: E501

    The version of the OpenAPI document: 3.22.0
    Contact: support@delphix.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from delphix.api.gateway.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from delphix.api.gateway.exceptions import ApiAttributeError


def lazy_import():
    from delphix.api.gateway.model.data_connection_capability import DataConnectionCapability
    from delphix.api.gateway.model.tag import Tag
    globals()['DataConnectionCapability'] = DataConnectionCapability
    globals()['Tag'] = Tag


class SubConnection(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('source_object_type',): {
            'CONNECTOR': "CONNECTOR",
            'SOURCE': "SOURCE",
            'VDB': "VDB",
            'STAGING_SOURCE': "STAGING_SOURCE",
        },
        ('metadata_home_type',): {
            'ENGINE': "ENGINE",
            'DCT': "DCT",
        },
        ('connection_mode',): {
            'FTP': "FTP",
            'MOUNT': "MOUNT",
            'SFTP': "SFTP",
            'FTPS': "FTPS",
            'AWS_S3': "AWS_S3",
            'S3_COMPATIBLE': "S3_COMPATIBLE",
        },
    }

    validations = {
        ('virtualization_environment_id',): {
            'max_length': 256,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'data_connection_id': (str,),  # noqa: E501
            'capability': (DataConnectionCapability,),  # noqa: E501
            'schema_name': (str,),  # noqa: E501
            'platform': (str,),  # noqa: E501
            'hostnames': ([str],),  # noqa: E501
            'source_object_type': (str,),  # noqa: E501
            'source_object_id': (str,),  # noqa: E501
            'metadata_home_type': (str,),  # noqa: E501
            'metadata_home_id': (str,),  # noqa: E501
            'metadata_home_name': (str,),  # noqa: E501
            'username': (str,),  # noqa: E501
            'database_name': (str,),  # noqa: E501
            'instance_name': (str,),  # noqa: E501
            'database_type': (str,),  # noqa: E501
            'jdbc_url': (str,),  # noqa: E501
            'is_replica': (bool,),  # noqa: E501
            'custom_driver_name': (str,),  # noqa: E501
            'virtualization_environment_id': (str,),  # noqa: E501
            'path': (str,),  # noqa: E501
            'connection_mode': (str,),  # noqa: E501
            'tags': ([Tag],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'data_connection_id': 'data_connection_id',  # noqa: E501
        'capability': 'capability',  # noqa: E501
        'schema_name': 'schema_name',  # noqa: E501
        'platform': 'platform',  # noqa: E501
        'hostnames': 'hostnames',  # noqa: E501
        'source_object_type': 'source_object_type',  # noqa: E501
        'source_object_id': 'source_object_id',  # noqa: E501
        'metadata_home_type': 'metadata_home_type',  # noqa: E501
        'metadata_home_id': 'metadata_home_id',  # noqa: E501
        'metadata_home_name': 'metadata_home_name',  # noqa: E501
        'username': 'username',  # noqa: E501
        'database_name': 'database_name',  # noqa: E501
        'instance_name': 'instance_name',  # noqa: E501
        'database_type': 'database_type',  # noqa: E501
        'jdbc_url': 'jdbc_url',  # noqa: E501
        'is_replica': 'is_replica',  # noqa: E501
        'custom_driver_name': 'custom_driver_name',  # noqa: E501
        'virtualization_environment_id': 'virtualization_environment_id',  # noqa: E501
        'path': 'path',  # noqa: E501
        'connection_mode': 'connection_mode',  # noqa: E501
        'tags': 'tags',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """SubConnection - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): ID of the sub connection.. [optional]  # noqa: E501
            name (str): Name of the sub connection.. [optional]  # noqa: E501
            data_connection_id (str): ID of the parent data connection.. [optional]  # noqa: E501
            capability (DataConnectionCapability): [optional]  # noqa: E501
            schema_name (str): The database schema name.. [optional]  # noqa: E501
            platform (str): The dataset platform of the data connection.. [optional]  # noqa: E501
            hostnames ([str]): The combined port and hostname or IP address values for the sub-connection.. [optional]  # noqa: E501
            source_object_type (str): The object type of the source entity representing the sub-connection.. [optional]  # noqa: E501
            source_object_id (str): The id of the source entity.. [optional]  # noqa: E501
            metadata_home_type (str): The object type of the entity storing the sub-connection.. [optional]  # noqa: E501
            metadata_home_id (str): The id of the entity storing the sub-connection. [optional]  # noqa: E501
            metadata_home_name (str): The name of the entity storing the sub-connection. [optional]  # noqa: E501
            username (str): The username used to connect to the sub-connection.. [optional]  # noqa: E501
            database_name (str): The name of the database on the target environment or in the database management system.. [optional]  # noqa: E501
            instance_name (str): The instance name of this dataset/connector.. [optional]  # noqa: E501
            database_type (str): The type of database.. [optional]  # noqa: E501
            jdbc_url (str): The jdbc URL for this dataset/connector.. [optional]  # noqa: E501
            is_replica (bool): Is this a replicated object.. [optional]  # noqa: E501
            custom_driver_name (str): The name of the custom JDBC driver.. [optional]  # noqa: E501
            virtualization_environment_id (str): The ID of the virtualization environment.. [optional]  # noqa: E501
            path (str): The path to the FILE data on the remote host.. [optional]  # noqa: E501
            connection_mode (str): The connection mode for file connectors.. [optional]  # noqa: E501
            tags ([Tag]): The tags associated with this sub-connection.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SubConnection - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): ID of the sub connection.. [optional]  # noqa: E501
            name (str): Name of the sub connection.. [optional]  # noqa: E501
            data_connection_id (str): ID of the parent data connection.. [optional]  # noqa: E501
            capability (DataConnectionCapability): [optional]  # noqa: E501
            schema_name (str): The database schema name.. [optional]  # noqa: E501
            platform (str): The dataset platform of the data connection.. [optional]  # noqa: E501
            hostnames ([str]): The combined port and hostname or IP address values for the sub-connection.. [optional]  # noqa: E501
            source_object_type (str): The object type of the source entity representing the sub-connection.. [optional]  # noqa: E501
            source_object_id (str): The id of the source entity.. [optional]  # noqa: E501
            metadata_home_type (str): The object type of the entity storing the sub-connection.. [optional]  # noqa: E501
            metadata_home_id (str): The id of the entity storing the sub-connection. [optional]  # noqa: E501
            metadata_home_name (str): The name of the entity storing the sub-connection. [optional]  # noqa: E501
            username (str): The username used to connect to the sub-connection.. [optional]  # noqa: E501
            database_name (str): The name of the database on the target environment or in the database management system.. [optional]  # noqa: E501
            instance_name (str): The instance name of this dataset/connector.. [optional]  # noqa: E501
            database_type (str): The type of database.. [optional]  # noqa: E501
            jdbc_url (str): The jdbc URL for this dataset/connector.. [optional]  # noqa: E501
            is_replica (bool): Is this a replicated object.. [optional]  # noqa: E501
            custom_driver_name (str): The name of the custom JDBC driver.. [optional]  # noqa: E501
            virtualization_environment_id (str): The ID of the virtualization environment.. [optional]  # noqa: E501
            path (str): The path to the FILE data on the remote host.. [optional]  # noqa: E501
            connection_mode (str): The connection mode for file connectors.. [optional]  # noqa: E501
            tags ([Tag]): The tags associated with this sub-connection.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
